# FILE: procs.tcl
#
# Misc. Tcl support code for the mmsolve application.
#

proc SlurpImageFile { filename varname } {
    # Fills $varname with a PPM representation of the data in filename
    upvar $varname var

    # First open file directly
    set chanid [open $filename r]
    set var [read $chanid 2]
    if {![string match P3 $var]} {
        # Input file is not PPM P3 (ASCII) type.  Send through filter.
        close $chanid
        set var {}
        set shell wish
        global tcl_platform
        if {[string match windows $tcl_platform(platform)]} { 
            set shell tclsh
        }
        set h [Oc_Application Resolve $shell]
        set shell [file join [$h Cget -directory] [$h Cget -file]]
        set g2pname [file join [file dirname [info nameofexecutable]] \
                .. gif2ppm.tcl]
        set chanid [open [list | $shell $g2pname -noinfo -o - $filename] r]
    }
    fconfigure $chanid -translation binary \
            -buffering full -buffersize 250000
    append var [read $chanid]
    close $chanid
}

